/* Copyright 1999 VLSI Vision Ltd. Free for use under the Gnu Public License */

#ifdef __cplusplus
extern "C"
{
#endif

#define MAX_LPT_PORTS			3

#define MAX_1284_DEVICE_ID		256


typedef enum {
	NO_ERROR,
	NO_PORT_ERROR,
	SET_TRANSFER_MODE_ERROR, 

	END_TRANSFER_MODE_ERROR,
	END_FAST_MODE_ERROR,

	FORWARD2REVERSE_ERROR,
	SIM_ECP_READ_ERROR,
	NIBBLE_READ_ERROR,

} CLINK_ERROR;	 



BOOL CLINK_Init( void );
void CLINK_Fini( void );


BOOL CLINK_DetectPort( BYTE PortNumber, WORD *BaseAddr, BYTE *PortType );
BOOL CLINK_SelectPort( BYTE PortNumber );	/* will initialise port the first time its selected */

BOOL CLINK_GetSelectedPort( BYTE *PortNumber );


BOOL CLINK_SendWakeup( void );
BOOL CLINK_Get1284DeviceID( char *DeviceID, WORD MaxLength ); 	/* use small MaxLength to 		*/ 
																/* check if camera alive		*/

BOOL CLINK_ForceWatchdogReset( void );

 
BOOL CLINK_GetPortInfo( WORD *BaseAddr, BYTE *PortType, WORD *Timeout_mS );
BOOL CLINK_SetPortInfo( BYTE PortType, WORD Timeout_mS );


BOOL CLINK_TransferMsg( BYTE  Module, BYTE  Proc, CMD_DATA *CmdData,
					    BOOL DataReadFlag, WORD DataBytes, DATA_BUFFER *DataBuffer );

BOOL CLINK_UploadStreamData( BOOL EndOnFF, DWORD DataBytes, BYTE __huge *DataBuffer, 
							 DWORD *ActualBytes, DWORD StreamChunkSize );


/* private functions */
int Get1284DeviceID( char __huge *DestString );

#ifdef __cplusplus
}
#endif




